<?php
/* -------------------------------------------------------------
Remote Execution Framework (REX) - Main Code

This file is part of the Remote Execution Framework (REX)
 
REX is (C) Copyright 2010 David Cutting
 
REX is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

REX is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with REX.  If not, see www.gnu.org/licenses
 
For more information see http://rex.purplepixie.org/
-------------------------------------------------------------- */




class REX
{
// Properties
var $Base=""; // Base Directory
var $Error=false; // Error Flag
var $ErrorList=array(); // List of Errors
var $Quiet=true; // Quiet Mode
var $Blocks=4096; // Fetch Block Size
var $Default="index.rex"; // Default file to look for in a directory
var $Env=array(); // Environment variables array
var $Var=array(); // Variable stack array


// Methods
function Get($key) // Get a variable from the stack (or false if not set)
{
	if (isset($this->Var[$key])) return $this->Var[$key];
	else return false;
}

function Set($key, $val) // Set a variable on the stack
	{
	$this->Var[$key]=$val;
	}

function EnvLoadArray(&$array,$name="") // Load an array into (or as) environment variables
{
if (!is_array($array)) return false;
if ( ($name != "") && (!isset($this->Env[$name])) ) $this->Env[$name]=array();
foreach($array as $key => $val)
	{
	if ($name=="") $this->Env[$key]=$val;
	else $this->Env[$name][$key]=$val;
	}
}

function EnvLoadHTTP() // Load common HTTP superglobals into Environment variables
{
	if (isset($_SERVER)) $this->EnvLoadArray($_SERVER,"_SERVER");
	if (isset($_REQUEST)) $this->EnvLoadArray($_REQUEST,"_REQUEST");
	if (isset($_POST)) $this->EnvLoadArray($_POST,"_POST");
	if (isset($_GET)) $this->EnvLoadArray($_GET,"_GET");
	if (isset($_COOKIE)) $this->EnvLoadArray($_COOKIE,"_COOKIE");
}

function EnvLoad($key,$val) // Load an environment variable (set it)
{
	$this->Env[$key]=$val;
}

function Fetch($filename) // Fetch a file (do not call directly)
{
$fp = @fopen($filename, "r");
if ($fp <= 0)
	{
	$this->ErrorList[]="Failed to open file ".$filename;
	$this->Error=true;
	return false;
	}
$buffer="";
while (!feof($fp))
	{
	$buffer .= fgets($fp,4096);
	}
fclose($fp);
return $buffer;
}

function Pad($data) // Pad the eval() bit - do not call directly
{
return "?>\n".$data."\n<?php\n";
}

function Exec($filename) // Execute a file with REX - call from the API/executor
{
if ($this->Base == "") // no base set
	{
	$last_slash = strrpos($filename,"/");
	if ($last_slash == (strlen($filename)-1)) // at the end of the filename
		{
		$this->Base=$filename;
		$filename = $filename.$this->Default;
		}
	else
		{
		$path = substr($filename, 0, $last_slash+1);
		$this->Base = $path;
		}
	}
else // base is set
	{
	$protocol = substr($filename, 0, 6);
	if ( ($protocol != "http:/") && ($protocol != "file:/") && ($protocol != "https:") )
		$filename = $this->Base.$filename;
	}
	
$data = $this->Fetch($filename);
if ($data === false) return false;

$data=$this->Pad($data);

if (!$this->SafeExec($data))
	{
	$this->Error=true;
	$this->ErrorList[]="SafeExec failed for ".$filename;
	return false;
	}

$REX = &$this;
	
if ($this->Quiet) @eval($data);
else eval($data);

return true;
}

function SafeExec($data) // Text code for syntax errors - do not call directly
{
$data="return true; ".$data;
if ($this->Quiet) $result = @eval("return true; ".$data);
else $result = eval("return true; ".$data);
if ($result === false)
	{
	$this->Error=true;
	$this->ErrorList[]="Syntax or Parse Error in Code";
	return false;
	}
else return true;
}

function ExecFile($filename) // Execute a file (call from REX scripts only)
{
if ($this->Exec($filename)===false)
	{
	if ($this->Error)
		{
		echo $this->ErrorList[count($this->ErrorList)-1];
		}
	}
}

}
?>